%define name	mdadm
%define version	1.7.0
%define release	3mdk

%define use_dietlibc 0
%define use_uclibc 0
%define use_klibc 0

%ifarch %{ix86} x86_64 ppc
%define use_dietlibc 1
%endif

# we want to install in /sbin, not /usr/sbin...
%define _exec_prefix %{nil}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	A tool for managing Soft RAID under Linux
Source:		http://cgi.cse.unsw.edu.au/~neilb/source/mdadm/%{name}-%{version}.tar.bz2
Source1:	mdadm.init.bz2
Source2:	raidtabtomdadm.sh.bz2
Source3:	mdmpd-0.3.tar.bz2
Source4:	mdmpd.init.bz2
Patch2:		mdmpd-0.3-pid.patch.bz2
Patch101:	http://cgi.cse.unsw.edu.au/~neilb/source/mdadm/patch/applied/001Makefile.bz2
Patch102:	http://cgi.cse.unsw.edu.au/~neilb/source/mdadm/patch/applied/002Pidfile.bz2
Patch103:	http://cgi.cse.unsw.edu.au/~neilb/source/mdadm/patch/applied/003ManTypo.bz2
Patch104:	http://cgi.cse.unsw.edu.au/~neilb/source/mdadm/patch/applied/004MdassembleEnhance.bz2
URL:		http://www.cse.unsw.edu.au/~neilb/source/mdadm/
License:	GPL
Group:		System/Kernel and hardware
BuildRequires:	man groff groff-for-man
%if %{use_dietlibc}
BuildRequires: dietlibc-devel
%endif
%if %{use_uclibc}
BuildRequires: uClibc-devel
%endif
%if %{use_klibc}
BuildRequires: klibc-devel
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Prereq: rpm-helper, gawk

%description 
mdadm is a program that can be used to create, manage, and monitor
Linux MD (Software RAID) devices.

As such is provides similar functionality to the raidtools packages.
The particular differences to raidtools is that mdadm is a single
program, and it can perform (almost) all functions without a
configuration file (that a config file can be used to help with
some common tasks).

%prep
%setup -q -a 3
bzcat %{SOURCE2} > raidtabtomdadm.sh
chmod 644 ChangeLog
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1

%build
%if %{use_dietlibc}
make mdassemble CXFLAGS="%{optflags}" SYSCONFDIR="%{_sysconfdir}"
%endif
%if %{use_uclibc}
make mdadm.uclibc mdassemble.uclibc CXFLAGS="%{optflags}" SYSCONFDIR="%{_sysconfdir}"
%endif
%if %{use_klibc}
make mdassemble.klibc CXFLAGS="%{optflags}" SYSCONFDIR="%{_sysconfdir}"
%endif
make CXFLAGS="%{optflags}" SYSCONFDIR="%{_sysconfdir}"
#make -C mdmpd CXFLAGS="%{optflags}" SYSCONFDIR="%{_sysconfdir}"

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

make DESTDIR=%{buildroot} MANDIR=%{_mandir} BINDIR=%{_sbindir} install
#make -C mdmpd DESTDIR=%{buildroot} MANDIR=%{_mandir} BINDIR=%{_sbindir} install
install -D -m 644 mdadm.conf-example %{buildroot}%{_sysconfdir}/mdadm.conf

mkdir -p %{buildroot}%{_initrddir}
bzip2 -dc %{SOURCE1} > %{buildroot}%{_initrddir}/mdadm
#bzip2 -dc %{SOURCE4} > %{buildroot}%{_initrddir}/mdmpd
#mkdir -p /var/run/mdmpd

%if %{use_dietlibc}
install mdassemble %{buildroot}%{_sbindir}/mdassemble
%endif
%if %{use_uclibc}
install mdassemble.uclibc %{buildroot}%{_sbindir}/mdassemble
%endif
%if %{use_klibc}
install mdassemble.klibc %{buildroot}%{_sbindir}/mdassemble
%endif


%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%preun
%_preun_service mdadm
#_preun_service mdmpd

%post -f raidtabtomdadm.sh
%_post_service mdadm
#_post_service mdmpd

%files
%defattr(644,root,root,755)
%doc TODO ChangeLog mdadm.conf-example ANNOUNCE-%{version}
%attr(755, root, root) %{_sbindir}/mdadm
#%attr(755, root, root) %{_sbindir}/mdmpd
%if %{use_dietlibc} || %{use_uclibc} || %{use_klibc}
%attr(755, root, root) %{_sbindir}/mdassemble
%endif
%config(noreplace,missingok)/%{_sysconfdir}/mdadm.conf
%attr(755, root, root) %config(noreplace) %{_initrddir}/mdadm
#%attr(755, root, root) %config(noreplace) %{_initrddir}/mdmpd
#%dir /var/run/mdmpd
%{_mandir}/man*/md*

%changelog
* Mon Sep 06 2004 Luca Berra <bluca@vodka.it> 1.7.0-3mdk 
- sync with patches merged upstream
- disable device autocreation in mdassemble for now

* Sun Aug 29 2004 Luca Berra <bluca@vodka.it> 1.7.0-2mdk 
- sync with patches merged upstream
- add raid6/raid10 to mdassemble as well
- mdassemble now supports device autocreation

* Mon Aug 23 2004 Luca Berra <bluca@vodka.it> 1.7.0-1mdk 
- 1.7.0
- build mdassemble on ppc as well
- mdadm daemon creates its own pid file
- convert raidtab in mdadm.conf
- prepare for inclusion of mdmpd

* Fri Jun 04 2004 Luca Berra <bluca@vodka.it> 1.6.0-1mdk 
- 1.6.0

* Sat Jan 24 2004 Luca Berra <bluca@vodka.it> 1.5.0-1mdk 
- 1.5.0
- drop patches included in the upstream source

* Mon Jan 19 2004 Luca Berra <bluca@vodka.it> 1.4.0-5mdk 
- added raid6 patches from hpa

* Sun Dec 21 2003 Luca Berra <bluca@vodka.it> 1.4.0-4mdk
- service name is mdadm

* Sat Dec 20 2003 Luca Berra <bluca@vodka.it> 1.4.0-3mdk
- updated with more patches from Neil, mdassemble is going to be integrated upstream
- added mdmonitor (from rh)

* Sun Nov 02 2003 Luca Berra <bluca@vodka.it> 1.4.0-2mdk
- added mdassemble built with dietlibc

* Fri Oct 31 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.4.0-1mdk
- 1.4.0
- drop patches included in the upstream source

* Mon Sep 08 2003 Guillaume Rousse <guillomovitch@linux-mandrake.com> 1.3.0-2mdk
- updated by Luca Berra <bluca@vodka.it>
 - added patches from upstream maintainer
- fix perms on doc file

* Tue Jul 29 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.3.0-1mdk
- 1.3.0

* Fri Apr 25 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.2.0-2mdk
- fix buildrequires, thanks to Stefan van der Eijks robot

* Sun Mar 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.2.0-1mdk
- 1.2.0

* Mon Mar 03 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.0-1mdk
- 1.1.0
- misc spec file fixes

* Thu Jan 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.1-3mdk
- build release

* Sun Aug  4 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.1-2mdk
- rebuilt with gcc-3.2

* Mon Jun 10 2002 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.0.1-1mdk
- 1.0.1
- capitalized summary to please rpmlint

* Mon May 20 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.0-2mdk
- rebuilt with gcc3.1

* Sat May 11 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.0-1mdk
- new version

* Sat May 11 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.8.2-1mdk
- initial cooker contrib
- used provided spec file
